package edu.ehu.gb.tap;

import java.io.*;
import java.util.*;

/**
 *
 * @author Clase
 */
public class Language {

    private final String id, descriptor;
    private final Map<Integer, Double> estadisticas=new TreeMap<>();

    public String getId() {return id;}
    public String getDescriptor() {return descriptor;}


    public Language(String id, String descriptor, String filename) throws  IOException {
        this.id = id;
        this.descriptor = descriptor;
        //Construcción del mapa a partir del fichero
        BufferedReader br=new BufferedReader(new FileReader(filename));
        int c;
        while ((c=br.read())!=-1) 
            estadisticas.put(c, estadisticas.get(c)==null?1:estadisticas.get(c)+1);
        //Normalización: de cuentas a frecuencias.
        int suma=0;
        for (double d:estadisticas.values()) suma+=d;
        for (Integer i:estadisticas.keySet()) 
            estadisticas.put(i,estadisticas.get(i)/suma);
    }

    public static double similarity(Language a, Language b){
        double suma=0;
        for (Integer i:a.estadisticas.keySet())
            suma+=Math.min(a.estadisticas.get(i), b.estadisticas.get(i)==null?0:b.estadisticas.get(i));
        return suma;    
    }
        
    @Override
    public String toString() {
        return "Language{" + "id=" + id + ", descriptor=" + descriptor + ", estadisticas=" + estadisticas + '}';
    }
}

  
